package com.bsf.lovDemo.util.help;

import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;

/**
 * The model for the help navigator tree.
 */
public class HelpTreeModel extends DefaultTreeModel {
    public static HelpNode CHAPTER_GENERAL = HelpNode.createChapter( "General" );
    public static HelpNode DATASET = HelpNode.createTopic( "Dataset", "docs/dataset.html" );
    public static HelpNode DEPLOY_INFOS = HelpNode.createTopic( "Deployement", "docs/deploy.html" );
    public static HelpNode THANKS = HelpNode.createTopic( "Thanks", "docs/thanks.html" );

    public static HelpNode CHAPTER_LOV_IN_TABLE = HelpNode.createChapter( "LOV in a table" );
    public static HelpNode TABLE_WHY_AND_HOW = HelpNode.createTopic( "Why and how ?", "docs/table_why_how.html" );
    public static HelpNode TABLE_FIELD_SELECTION = HelpNode.createTopic( "Field selection", "docs/table_field_selection.html" );

    public static HelpNode CHAPTER_LOV_IN_DETAIL = HelpNode.createChapter( "LOV in a combo box" );
    public static HelpNode DETAIL_WHY_AND_HOW = HelpNode.createTopic( "Why and how ?", "docs/detail_why_how.html" );
    public static HelpNode DETAIL_FIELD_SELECTION = HelpNode.createTopic( "Field selection", "docs/detail_field_selection.html" );

    public static HelpNode CHAPTER_LOV_CUSTOMIZATION = HelpNode.createChapter( "LOV customization" );
    public static HelpNode CUSTOMIZATION_HOW = HelpNode.createTopic( "How to customize a LOV ?", "docs/customization_how.html" );

    public static HelpNode CHAPTER_LOV_PERFORMANCE = HelpNode.createChapter( "LOV performance" );
    public static HelpNode ABOUT_PERFORMANCE = HelpNode.createTopic( "How fast is it ?", "docs/performances.html" );

    {
        CHAPTER_GENERAL.insert( DATASET, 0 );
        CHAPTER_GENERAL.insert( DEPLOY_INFOS, 1 );
        CHAPTER_GENERAL.insert( THANKS, 2 );

        CHAPTER_LOV_IN_TABLE.insert( TABLE_WHY_AND_HOW, 0 );
        CHAPTER_LOV_IN_TABLE.insert( TABLE_FIELD_SELECTION, 1 );

        CHAPTER_LOV_IN_DETAIL.insert( DETAIL_WHY_AND_HOW, 0 );
        CHAPTER_LOV_IN_DETAIL.insert( DETAIL_FIELD_SELECTION, 1 );

        CHAPTER_LOV_CUSTOMIZATION.insert( CUSTOMIZATION_HOW, 0 );

        CHAPTER_LOV_PERFORMANCE.insert( ABOUT_PERFORMANCE, 0 );

        ( (MutableTreeNode) getRoot() ).insert( CHAPTER_GENERAL, 0 );
        ( (MutableTreeNode) getRoot() ).insert( CHAPTER_LOV_IN_TABLE, 1 );
        ( (MutableTreeNode) getRoot() ).insert( CHAPTER_LOV_IN_DETAIL, 2 );
        ( (MutableTreeNode) getRoot() ).insert( CHAPTER_LOV_CUSTOMIZATION, 3 );
        ( (MutableTreeNode) getRoot() ).insert( CHAPTER_LOV_PERFORMANCE, 4 );
    }

    public HelpTreeModel() {
        super( HelpNode.getRootNode() );
    }
}
